/****************************************************************
Types class
Check types of values, variables.
Use typename(source) as parameter.
/****************************************************************/
class Types
  {
public:
   bool              IsNumeric(string type);
   bool              IsFloatingPoint(string type) {return (type=="float"||type=="double");}
   bool              IsSimple(string type);
   bool              IsComplex(string type) {return (!IsSimple(type));}

   template<typename T>int Bits(T src) {return sizeof(typename(T))*8;}
   template<typename T>int BitsByref(T &src) {return sizeof(typename(T))*8;}
   template<typename T>int Bits(T &src[]) {return sizeof(typename(T))*8;}
  };
/****************************************************************/
bool Types::IsSimple(string type)
  {
   return (type=="char"||type=="uchar"
           ||type=="short"||type=="ushort"
           ||type=="int"||type=="uint"
           ||type=="long"||type=="ulong"
           ||type=="float"||type=="double"
           ||(StringFind(type,"ENUM")>-1)||type=="datetime"
           ||type=="bool"||type=="color");
  }
/****************************************************************/
bool Types::IsNumeric(string type)
  {
   return (type=="char"||type=="uchar"
           ||type=="short"||type=="ushort"
           ||type=="int"||type=="uint"
           ||type=="long"||type=="ulong"
           ||type=="float"||type=="double");
  }
/**/
